release vars all
release procs all
; File name: DEMO.SC
;
; Script to build library and then execute the demo
;

message "Making library - Please wait.."

play "FBUT"       ;  Build floating button library

message "Creating lib DEMO, Please wait .."
createlib "demo"
release procs wproc
 proc wproc(x)
    execute "writelib \"demo\" " + x
    + " release procs " + x
 endproc


;======================================================= Demo_Menu_Proc
proc Demo_Menu_Proc
; Display DEMO menu
(
)
clearspeedbar
prompt ""

showpulldown
"Form"
    : "Demo of floating windows and a form"
    : "Form",
"Dialog"
    : "Demo of floating windows and a dialog"
    : "Dialog",
"Canvas"
    : "Demo of floating windows and a canvas window"
    : "Canvas",
"Words"
    : "Read the documentation"
    : "Words"
    submenu
    "Readme"
    	: "View the $$README file via the Paradox editor"
    	: "Words/Readme",
    "ProcDoc"
    	: "View procedure documentation via the Paradox editor"
    	: "Words/ProcDoc"
    endsubmenu,
"Exit"
    : "Exit from demo"
    : "Exit"
endmenu

endproc
wproc( "Demo_Menu_Proc" )

;======================================================= Demo_1
proc Demo_1
; Demo a form that looks like a dialog box
(
)
private x, y, z
	, form.winhand
	, ok.winhand
	, f2.winhand
	, cancel.winhand
	, undo.winhand
	, esc.winhand
	, name.winhand
	, phone.winhand
	, type.winhand
	, type.rb.winhand
	, radlab
	, ok.wid
	, phone.type

ok.wid = 10

view "samp"
coeditkey
pickform 1

echo normal

; Do a window select so it can be correctly restored after
; floating window creation.

window handle form to form.winhand
window select form.winhand

; Don't let the form wiggle around on the screen or
; the floating overlays will be out of alignment.

dynarray x[]
x[ "canclose" ] = false
x[ "canmaximize" ] = false
x[ "canmove" ] = false
x[ "canresize" ] = false
x[ "maximized" ] = true

window setattributes form.winhand from x
release vars x

; Set colors to the dialog box colors. We want the form to
; resemble a dialog box.

dynarray x[]
x[ 0 ] = syscolor( 1032 )  ; use active color
x[ 1 ] = syscolor( 1032 )
x[ 2 ] = syscolor( 1032 )

window setcolors form.winhand from x
release vars x

; Temporarily change the button colors so that the
; field labels will match the form's background color.

y = fbut.color.button.window.active
z = fbut.color.button.hotkey.active
fbut.color.button.window.active = 112
fbut.color.button.hotkey.active = 112 + 14

; The following buttons are used as field labels. They overlay
; window text fields that are identical in appearance.

name.winhand = FBUT_Button( form.winhand, 4, 4, 4
	, "~N~ame", 0, "Demo_1_Name", true )

phone.winhand = FBUT_Button( form.winhand, 7, 4, 5
	, "~P~hone", 0, "Demo_1_Phone", true )

type.winhand = FBUT_Button( form.winhand, 10, 4, 4
	, "~T~ype", 0, "Demo_1_Type", true )

fbut.color.button.window.active = y
fbut.color.button.hotkey.active = z

; Add an Ok and Cancel button (cancel means UNDO for this example)

ok.winhand = FBUT_Button( form.winhand, 17, 26, ok.wid
	, "Ok", 0, "Demo_1_Ok", true )

cancel.winhand = FBUT_Button( form.winhand, 17, 37, ok.wid
	, "Cancel", 0, "Demo_1_Cancel", true )

; Define the labels for the radiobutton

dynarray radlab[]
radlab[ 0 ] = "Select type of phone"
radlab[ 1 ] = "Business"
radlab[ 2 ] = "Home"

phone.type = 1

type.rb.winhand = FBUT_Radio( form.winhand, 10, 16, 24
	, radlab, 0, "Demo_1_Type_Chosen", "phone.type", false )

; Add some invisible buttons for extra hotkeys

; F2 pushes the Ok button

f2.winhand = FBUT_Button( 0, 0, 0, ok.wid
	, " ", asc( "f2" ), "Demo_1_Ok", false )
FBUT_Active( f2.winhand, true )

; Esc pushes cancel

esc.winhand = FBUT_Button( 0, 0, 0, ok.wid
	, " ", asc( "esc" ), "Demo_1_Cancel", false )
FBUT_Active( esc.winhand, true )

; Ctrl-U pushes the cancel button

undo.winhand = FBUT_Button( 0, 0, 0, ok.wid
	, " ", 21, "Demo_1_Cancel", false )
FBUT_Active( undo.winhand, true )

; echo is already normal for the wait

wait table
	proc "Demo_1_Wait"
	mouse "all"
	key "all"
	trigger "departfield", "arrivefield"
endwait

; Hide what we're doing

echo off
do_it!
clearimage
savetables
FBUT_Destroy( ok.winhand )
FBUT_Destroy( cancel.winhand )
FBUT_Destroy( name.winhand )
FBUT_Destroy( phone.winhand )
FBUT_Destroy( type.winhand )
FBUT_Destroy( type.rb.winhand )
FBUT_Destroy( f2.winhand )
FBUT_Destroy( esc.winhand )
FBUT_Destroy( undo.winhand )

; Show the blank desktop to the user

echo normal echo off

endproc
wproc( "Demo_1" )

;======================================================= Demo_1_Ok
proc Demo_1_Ok
; Return 2 to end wait
(
)

return 2

endproc
wproc( "Demo_1_Ok" )

;======================================================= Demo_1_Cancel
proc Demo_1_Cancel
; Undo changes and return 1 to stay in wait
(
)

if recordstatus( "modified" ) then
	if lower( field() ) = "type" then
		Demo_1_Type_RB( false )
	endif
	echo off
	undo
	echo normal
	DEMO_3( "Changes to this record have been cancelled!" )
	if lower( field() ) = "type" then
		Demo_1_Type_RB( true )
	endif
else
	DEMO_3( "There are no changes to this record!\nNothing to Cancel!" )
endif
	
return 1

endproc
wproc( "Demo_1_Cancel" )

;======================================================= Demo_1_Name
proc Demo_1_Name
; Move to the name field
(
)

Demo_1_Type_RB( false )
moveto [name]
return 1

endproc
wproc( "Demo_1_Name" )

;======================================================= Demo_1_Phone
proc Demo_1_Phone
; Move to the phone field
(
)

Demo_1_Type_RB( false )
moveto [phone]
return 1

endproc
wproc( "Demo_1_Phone" )

;======================================================= Demo_1_Type
proc Demo_1_Type
; Move to the type field and activate the radiobutton
(
)

moveto [type]
Demo_1_Type_RB( true )
return 1

endproc
wproc( "Demo_1_Type" )

;======================================================= Demo_1_Type_RB
proc Demo_1_Type_RB
; Change "active" and "visible" for the radiobutton for [type]
(
    t.or.f   ; TRUE->The radiobutton becomes active and visible
             ; FALSE-> We hide the rbutton and deactivate it
)

if t.or.f then
    ; If we are going to make the radiobutton active, we want
    ; to set its controlling var from the current record.
    ; We don't want the user to update the field directly, so
    ; we disallow updates.

	imagerights readonly
	if upper( [type] ) = "B" then
		phone.type = 1
	else
		phone.type = 2
	endif

	; We need to call update because the control var
	; changed and the radiobutton doesn't know it.
	FBUT_Update( type.rb.winhand )
else
	; We're leaving the type field, so we'll allow updates.
	imagerights
endif


FBUT_Active( type.rb.winhand, t.or.f )
FBUT_Visible( type.rb.winhand, t.or.f )
return 1

endproc
wproc( "Demo_1_Type_RB" )

;======================================================= Demo_1_Type_Chosen
proc Demo_1_Type_Chosen
; Set [type] when the user selects from the radiobutton
(
)

imagerights
if phone.type = 1 then
	[type] = "B"
else
	[type] = "H"
endif
imagerights readonly
return 1

endproc
wproc( "Demo_1_Type_Chosen" )

;======================================================= Demo_1_Wait
proc Demo_1_Wait
; Wait proc for Demo_1
(
    trig.type
  , evt
  , cyc.num
)
private x

switch
case trig.type = "EVENT" :
	if evt[ "type" ] = "KEY" or
	   evt[ "type" ] = "MOUSE" then

	   ; Strictly speaking, FBUT_Event should only be called for
	   ; MOUSE DOWN events and KEY events. However, we can call
	   ; it with any MOUSE event. It will only do something with
	   ; MOUSE DOWN.

		x = FBUT_Event( evt )
		if x > -1 then
			return x
		endif
	endif
case trig.type = "ARRIVEFIELD" :
	if lower( field() ) = "type" then
		; Show the radiobutton
		Demo_1_Type_RB( true )
	endif
case trig.type = "DEPARTFIELD" :
	if lower( field() ) = "type" then
		; Hide the radiobutton
		Demo_1_Type_RB( false )
	endif
endswitch
return 0

endproc
wproc( "Demo_1_Wait" )

;======================================================= Demo_2
proc Demo_2
; Demo a dialog with a floating checkbox and button
(
)
private x, y, z
	, butval
	, fake.winhand
	, type.rb.winhand
	, dlg.winhand
	, radlab
	, x.name
	, x.phone
	, phone.type

; Create the floating "Fake" button and the radiobutton.

fake.winhand = FBUT_Button( 0, 10, 31, 8
	, "~F~ake", 0, "Demo_2_Fake", false )

dynarray radlab[]
radlab[ 1 ] = "Business"
radlab[ 2 ] = "Home"

phone.type = 1

x.name = "John Jones"
x.phone = "909-555-1212"

type.rb.winhand = FBUT_Radio( 0, 5, 10, 14
	, radlab, 0, "Demo_2_Type_Chosen", "phone.type", false )


butval = "cancel"

showdialog
	""
    proc "Demo_2_DProc"
        trigger "open"
        mouse "all" 
        key "all" 
;;        message "all"
;;        idle
	@ 4, 15
    height 15
    width 50

	label
		@ 1, 2
		"~N~ame"
		for "x.name"

	accept
		@ 1, 10
		width 34
		"A30"
		tag "x.name"
		to x.name

	label
		@ 3, 2
		"~P~hone"
		for "x.phone"

	accept
		@ 3, 10
		width 19
		"A15"
		tag "x.phone"
		to x.phone

	@ 5, 3
		?? "Type"

	@ 5, 26
		?? "You can't TAB to"
	@ 6, 26
		??  "the floating"
	@ 7, 26
		??  "RadioButton or"
	@ 8, 26
		??  "the Fake button"


	pushbutton
		@ 10, 10
		width 10
		"Ok"
		ok
		default
		value "ok"
		tag "ok"
		to butval

	pushbutton
		@ 10, 20
		width 10
		"Cancel"
		cancel
		value "cancel"
		tag "cancel"
		to butval

;   Paint the shadow for the "Fake" button. We want it to look real.

	paintcanvas fill chr( 223 ) attribute syscolor( 1045 ) 11, 32, 11, 39
	paintcanvas fill chr( 220 ) attribute syscolor( 1045 ) 10, 39, 10, 39

enddialog

FBUT_Destroy( type.rb.winhand )
FBUT_Destroy( fake.winhand )

endproc
wproc( "Demo_2" )

;================================================== Demo_2_DProc
proc Demo_2_DProc
; Dialog proc for Demo_2 dialog
;
; Return Value:
; True if the event is to be processed.
; False if the event is to be ignored.
(
    dlg.trig     ; "Event" or one of the following triggers:
                 ; "Update", "Depart", "Select"
                 ; "Accept", "Cancel", "Arrive"
                 ; "Open", "Close"
  , dlg.tag      ; The tag for the active control element
  , dlg.evt      ; Dynarray for event.
                 ; If "Update", value of active control element.
                 ; If "Depart", tag that you will navigate to.
                 ; Null string if any other trigger.
  , dlg.cb.lbl   ; Null string if event.
                 ; If "Update" trigger, label string of checkbox or
                 ; null string.
                 ; Null string if any other trigger.
)
private x
switch
case dlg.trig = "EVENT" :
    if dlg.evt[ "type" ] = "KEY" or
       dlg.evt[ "type" ] = "MOUSE" then

        ; If FBUT_Event handles the event, return TRUE.
        ; The handler proc can issue dialog commands, if
        ; necessary. If it wants to close the dialog, it
        ; can use canceldialog or acceptdialog.
        
		x = FBUT_Event( dlg.evt )
		if x <> - 1 then
			return true
		endif
	endif
    switch
    case dlg.evt[ "type" ] = "IDLE"    : return false
    case dlg.evt[ "type" ] = "KEY"     : return true
    case dlg.evt[ "type" ] = "MOUSE"   : return true
    case dlg.evt[ "type" ] = "MESSAGE" : return true
    endswitch
case dlg.trig = "UPDATE" : return true
case dlg.trig = "DEPART" : return true
case dlg.trig = "SELECT" : return true
case dlg.trig = "ACCEPT" : return true
case dlg.trig = "ARRIVE" : return true
case dlg.trig = "OPEN"   : return Demo_2_Open()
case dlg.trig = "CANCEL" : return true
case dlg.trig = "CLOSE"  : return true
endswitch
return true

endproc
wproc( "Demo_2_DProc" )

;======================================================= Demo_2_Open
proc Demo_2_Open
; Handles the OPEN trigger
;
; Makes the floating "Fake" button and radiobutton visible
(
)
private x

; Get the window handle for the dialog, unfloat the dialog,
; make the dialog the parent of the floating windows, and
; make the floating windows active and visible.

window handle dialog to dlg.winhand
window select dlg.winhand
dynarray x[]
x[ "floating" ] = false
window setattributes dlg.winhand from x
release vars x
FBUT_Move( fake.winhand, dlg.winhand, "", "" )
FBUT_Move( type.rb.winhand, dlg.winhand, "", "" )
FBUT_Active( fake.winhand, true )
FBUT_Active( type.rb.winhand, true )
FBUT_Visible( type.rb.winhand, true )
FBUT_Visible( fake.winhand, true )

return true

endproc
wproc( "Demo_2_Open" )

;======================================================= Demo_2_Type_Chosen
proc Demo_2_Type_Chosen
; Just return 1
(
)

return 1

endproc
wproc( "Demo_2_Type_Chosen" )

;======================================================= Demo_2_Fake
proc Demo_2_Fake
; Issue message and return 1
(
)
message "You pressed the Fake button"
sleep 1000
message ""
return 1

endproc
wproc( "Demo_2_Fake" )

;======================================================= Demo_3
proc Demo_3
; Demo a floating message window with a floating OK
(
    msgx         ; the message
)
private x, y, z
	, orig.win
	, orig.canv
	, msgw
	, num.lines
	, widest.line
	, backdrop.hgt
	, backdrop.wid
	, backdrop.row
	, backdrop.col
	, backdrop.winhand
	, msg.hgt
	, msg.wid
	, msg.row
	, msg.col
	, msg.winhand
	, msg.can.wid
	, msg.can.hgt
	, ok.row
	, ok.col
	, ok.wid
	, scroll.col
	, scroll.row
	, win.attr

	; All of the floater global vars must be declared
	; as private vars. We don't want any active floaters to
	; eat the hotkey or mouse events for the message window.

	, fbut.window.parent
	, fbut.window.info
	, fbut.label.info
	, fbut.hotkey.list
	, fbut.color.button.window.active
	, fbut.color.button.hotkey.active
	, fbut.color.button.window.inactive
	, fbut.color.button.hotkey.inactive
	, fbut.color.radio.window.active
	, fbut.color.radio.title.active
	, fbut.color.radio.hotkey.active
	, fbut.color.radio.window.inactive
	, fbut.color.radio.title.inactive
	, fbut.color.radio.hotkey.inactive
	, fbut.color.check.window.active
	, fbut.color.check.title.active
	, fbut.color.check.hotkey.active
	, fbut.color.check.window.inactive
	, fbut.color.check.title.inactive
	, fbut.color.check.hotkey.inactive
	, fbut.draw.proc
	, fbut.paint.proc
	, fbut.update.proc
	, fbut.winreg
	, fbut.labelreg
	, fbut.globals.are.initialized

orig.win = getwindow()
orig.canv = getcanvas()

; Init the private copy of the globals

FBUT_Init_Globals()

dynarray msgw[]
msgw[ "string" ] = msgx
msgw[ "width" ] = 72
Demo_Word_Wrap( msgw )

; Calc window sizes and locations. Pretty dry stuff.

num.lines = min( msgw[ "lines" ], 200 )
widest.line = msgw[ "longest" ]  ; won't exceed msgw[ "width" ]

ok.wid = 10

msg.can.wid = widest.line + 2   ; margins
msg.can.wid = max( msg.can.wid, ok.wid )

msg.can.hgt = num.lines
msg.can.hgt = max( msg.can.hgt, 1 )
msg.can.hgt = min( msg.can.hgt, 200 )

msg.wid = msg.can.wid + 2
msg.wid = min( msg.wid, 76 )
msg.hgt = min( msg.can.hgt, 17 )

backdrop.wid = msg.wid + 4 ; margins
backdrop.hgt = msg.hgt + 6 ; top margin (2) + button space

backdrop.row = int( ( 24 - backdrop.hgt ) / 2 )
backdrop.col = int( ( 80 - backdrop.wid ) / 2 )

msg.row = backdrop.row + 2
msg.col = backdrop.col + 2

ok.row = msg.row + msg.hgt - backdrop.row
ok.col = int( ( backdrop.wid - ok.wid ) / 2 )

; Create the floating backdrop window

dynarray x[]
x[ "canclose" ] = false
x[ "canmaximize" ] = false
x[ "canmove" ] = false
x[ "canresize" ] = false
x[ "canvasheight"] = backdrop.hgt - 2
x[ "canvaswidth" ] = backdrop.wid - 2
x[ "floating" ] = true
x[ "hasframe" ] = true
x[ "hasshadow" ] = false
x[ "height" ] = backdrop.hgt
x[ "maximized" ] = false
;; x[ "title" ] = "** ERROR **"
x[ "origincol" ] = backdrop.col
x[ "originrow" ] = backdrop.row
x[ "width" ] = backdrop.wid

window create attributes x to backdrop.winhand
release vars x

; Set colors to the dialog box colors - they usually look good.

dynarray x[]
x[ 0 ] = syscolor( 1032 )  ; use active color
x[ 1 ] = syscolor( 1032 )
x[ 2 ] = syscolor( 1032 )
x[ 3 ] = syscolor( 1034 )
x[ 4 ] = syscolor( 1035 )

window setcolors backdrop.winhand from x
setcanvas backdrop.winhand
paintcanvas attribute syscolor( 1036 ) all
release vars x

; Create the floating message window "inside" the larger
; backdrop window. The message window will not be framed
; unless the text has more lines than the screen can hold.

; By the way - this demo assumes a screen size of 24x80.
; We could use sysinfo to get the actual size but this
; is only a demo - not a real application.

dynarray x[]
x[ "canclose" ] = false
x[ "canmaximize" ] = false
x[ "canmove" ] = false
x[ "canresize" ] = false
x[ "canvasheight"] = msg.can.hgt
x[ "canvaswidth" ] = msg.can.wid
x[ "floating" ] = true
x[ "hasframe" ] = ( msg.can.hgt > msg.hgt )
x[ "hasshadow" ] = false
x[ "height" ] = msg.hgt
x[ "maximized" ] = false
x[ "origincol" ] = msg.col
x[ "originrow" ] = msg.row
x[ "width" ] = msg.wid

window create attributes x to msg.winhand
setcanvas msg.winhand
release vars x

dynarray x[]
x[ 0 ] = syscolor( 1032 )  ; use active color
x[ 1 ] = syscolor( 1032 )
x[ 2 ] = syscolor( 1032 )
x[ 3 ] = syscolor( 1034 )
x[ 4 ] = syscolor( 1035 )

window setcolors msg.winhand from x

; Create extra hotkey buttons. They are active but not visible.

x = FBUT_Button( 0, 0, 0, ok.wid
	, " ", asc( "enter" ), "Demo_3_Ok", false )
FBUT_Active( x, true )

x = FBUT_Button( 0, 0, 0, ok.wid
	, " ", asc( "esc" ), "Demo_3_Ok", false )
FBUT_Active( x, true )

; Create the Ok button that displays under the message window.

FBUT_Button( backdrop.winhand, ok.row, ok.col, ok.wid
	, "Ok", 0, "Demo_3_Ok", true )

; Put the message in the window and paint the entire window
; using the system's message color.

for x from 1 to num.lines
	@ x - 1, 1 ?? msgw[ x ]
endfor

paintcanvas attribute syscolor( 3 ) all

; Wait for the user to press Ok. If the message window is
; scrollable, the scroll commands are handled.

while true
	getevent key "all" mouse "all" to evt
	x = FBUT_Event( evt )
	switch
	case x = -1 :
		switch
		case evt[ "type" ] = "KEY" :
			;
			;   Scrolling keys
			;
			scroll.row = 0
			scroll.col = 0

			switch
			case evt[ "keycode" ] = -71 :  ; Home
				scroll.col = -1000         ; Scroll to left of canvas

			case evt[ "keycode" ] = -72 :  ; Up
				scroll.row = -1

			case evt[ "keycode" ] = -73 :  ; PgUp
				scroll.row = -msg.hgt - 1  ; 1 less than height

			case evt[ "keycode" ] = -75 :  ; Left
				scroll.col = -1

			case evt[ "keycode" ] = -77 :  ; Right
				scroll.col = 1

			case evt[ "keycode" ] = -79 :  ; End
				scroll.col = 1000          ; Scroll to right end of canvas

			case evt[ "keycode" ] = -80 :  ; Down
				scroll.row = 1

			case evt[ "keycode" ] = -81 :  ; PgDn
				scroll.row = msg.hgt - 3   ; 1 less than height

			case evt[ "keycode" ] = -115 : ; Ctrl-Left
				scroll.col = -msg.wid - 1  ; 1 less than width

			case evt[ "keycode" ] = -116 : ; Ctrl-Right
				scroll.col = msg.wid - 3   ; 1 less than width

			case evt[ "keycode" ] = -117 : ; Ctrl-End
				scroll.row = 1000          ; Scroll to bottom of canvas
				scroll.col = 1000          ; Scroll to right end of canvas

			case evt[ "keycode" ] = -118 : ; Ctrl-PgDn
				scroll.row = 1000          ; Scroll to bottom of canvas

			case evt[ "keycode" ] = -119 : ; Ctrl-Home
				scroll.row = -1000         ; Scroll to top of canvas
				scroll.col = -1000         ; Scroll to left end of canvas

			case evt[ "keycode" ] = -132 : ; Ctrl-PgUp
				scroll.row = -1000         ; Scroll to top of canvas

			otherwise :
				beep

			endswitch

			window getattributes msg.winhand to win.attr
			scroll.row = scroll.row + win.attr[ "scrollrow" ]
			scroll.row = max( scroll.row, 0 )
			scroll.row = min( scroll.row
				, win.attr[ "canvasheight" ] - msg.hgt )
			scroll.row = max( scroll.row, 0 )
			scroll.col = scroll.col + win.attr[ "scrollcol" ]
			scroll.col = max( scroll.col, 0 )
			scroll.col = min( scroll.col
				, win.attr[ "canvaswidth" ] - msg.wid )
			scroll.col = max( scroll.col, 0 )
			window scroll msg.winhand to scroll.row, scroll.col

		case evt[ "type" ] = "MOUSE" :
			localizeevent evt
			if evt[ "window" ] = msg.winhand then
				globalizeevent evt
				execevent evt
			endif
		endswitch
	case x = 2 :
		quitloop
	endswitch
endwhile

; Kill all the floating windows.
	
FBUT_Destroy_All()
window select msg.winhand
window close
window select backdrop.winhand
window close

if iswindow( orig.canv ) then
	setcanvas orig.canv
else
	setcanvas default
endif
if iswindow( orig.win ) then
	window select orig.win
endif

endproc
wproc( "Demo_3" )

;======================================================= Demo_3_Ok
proc Demo_3_Ok
; Returns 2 to end getevent loop for message window.
; The user pushed the Ok button.
(
)

return 2

endproc
wproc( "Demo_3_Ok" )

;===================================================== Demo_Word_Wrap
proc Demo_Word_Wrap
; Word wraps a string.
;
; Return Value:
; None.
; 
; This proc updates the dynarray parameter as follows:
;
;   str["lines"] is set to the number of lines.
;
;   str["longest"] is set to the length of the longest line after
;   wrapping.  This value will be less than or equal to str["width"].
;
;   str[n] is set to the contents of line n, 
;   where 1 <= n <= str["lines"].
(
    str     ; {I,O} Dynarray that contains the string to be word 
            ;       wrapped in the element str["string"] and the 
            ;       wrapping width in str["width"].
            ;       Wrapping width must be between 1 and 255.
)
private x, y
    , z            ; string from str["string"]
    , w            ; wrap width from str["width"]
    , s            ; current start pos in z
    , e            ; current end pos in z
    , sz        ; length of substring in z
    , lz        ; length of z

; Check parameters in str

if isassigned( str["string"] ) then
    z = str["string"]
else
    z = ""
endif

if isassigned( str["width"] ) then
    w = numval( str["width"] )
    if lower( strval( w ) ) = "error" then
        w = 20   ; default width
        z = z + "\n*** Invalid width passed ***"
    endif
    if w < 1 or w > 255 then
        w = 20   ; default width
        z = z + "\n*** Invalid width passed ***"
    endif
else
    w = 20       ; default width
    z = z + "\n*** No width passed ***"
endif

; Word wrap lines

str["lines"] = 0
str["longest"] = 0
s = 1
e = 1
lz = len( z )

while s <= lz
    e = searchfrom( "\n", z, s )
    if e > 0 and e - s <= w then
        sz = e - s   ; don't include \n
    else
        ; There is no \n in the w bytes starting at s.
        ; Look for rightmost blank or dash in string of width w.
        sz = 0
        e = s + w - 1
        while e > s and e < lz
            if substr( z, e, 1 ) = " " then
                sz = e - s  ; don't include trailing blank
                quitloop
            endif
            if substr( z, e, 1 ) = "-" then
                sz = e - s + 1 ; include trailing dash
                quitloop
            endif
            e = e - 1
        endwhile
        if sz = 0 then
            ; no natural breaks in line or at end of string - use 
            ; maximum width
            e = s + w -1
            e = min( e, lz )
            sz = e - s + 1
        endif
    endif
    ; trim trailing blanks from line (caller may want to center lines)
    y = substr( z, s, sz )
    while match( y, ".. ", y ) endwhile

    str["lines"] = str["lines"] + 1
    str[ str["lines"] ] = y
    if len( y ) > str["longest"] then
        str["longest"] = len( y )
    endif
    s = e + 1
endwhile

endproc
wproc( "Demo_Word_Wrap" )


message "Initializing DEMO"

autolib = "fbut,demo"

FBUT_Init_Globals()
Demo_Menu_Proc()
prompt ""

message ""

echo normal

while true
    getevent message "menuselect" to evt
    switch
    case evt[ "menutag" ] = "Form" :
    	echo off
    	showpulldown endmenu
        Demo_1()
		Demo_Menu_Proc()
		echo normal
    case evt[ "menutag" ] = "Dialog" :
        Demo_2()
		Demo_Menu_Proc()
    case evt[ "menutag" ] = "Canvas" :
    	showpulldown endmenu
        Demo_3( "This is a sample of a message box implemented\n"
			  + "using a floating window as the backdrop and\n"
			  + "another to hold the message text.\n\n"
			  + "A floating Ok button is used to wait for a\n"
			  + "response from the user." )
		fileread "canvas.txt" to msgx
		Demo_3( msgx )
		release vars msgx
		Demo_Menu_Proc()
    case evt[ "menutag" ] = "Words/Readme" :
        echo off
        editor open "$$README"
        window handle editor to edithand
        window maximize edithand
        clearpulldown
        echo normal
        while iswindow( edithand )
            getevent all to evtx
            execevent evtx
        endwhile
        Demo_Menu_Proc()
        release vars edithand, evtx
    case evt[ "menutag" ] = "Words/ProcDoc" :
        echo off
    	if not isfile( "fbut.doc" ) then
    		message "Extracting proc documentation from .SC files",
    			"   Please wait .."
    		sleep 1000
    		play "fbut-doc"
    	endif
        editor open "fbut.doc"
        window handle editor to edithand
        window maximize edithand
        clearpulldown
        echo normal
        while iswindow( edithand )
            getevent all to evtx
            execevent evtx
        endwhile
        Demo_Menu_Proc()
        release vars edithand, evtx
    case evt[ "menutag" ] = "Exit" :
        quitloop
    otherwise :
        message "Unrecognized menutag: \"", evt[ "menutag" ], "\""
        quitloop
    endswitch
endwhile

message "DEMO is done"
sleep 1000

release vars evt
FBUT_Release_Globals()
